<template>
  <span class="wrapper">
    <span class="emoji" :style="iconCss">{{ emoji }}</span>
  </span>
</template>
<style scoped>
.wrapper {
  filter: drop-shadow(0 0 0.08em #0008);
}
.emoji {
  display: inline-block;
  transform: scale(0.85);
}
</style>
<script lang="ts">
import Vue, { defineComponent, PropType } from "vue";
export default defineComponent({
  name: "player-icon",
  props: {
    players: { type: Array as PropType<Player[]>, required: true },
    playerId: { type: Number, required: true },
  },
  computed: {
    allPlayerIds(): number[] {
      return this.players.map((p) => p.id) ?? [];
    },
    sortedPlayerIds() {
      const playerIds = this.players.map((p) => p.id);
      return playerIds.sort((a, b) => a - b);
    },
    idx(): number {
      return this.sortedPlayerIds.indexOf(this.playerId);
    },
    emoji(): string {
      switch (this.idx) {
        case 0:
          return "♠️";
        case 1:
          return "♥️";
        case 2:
          return "♦️";
        case 3:
          return "♣️";

        default:
          return "";
      }
    },
    iconCss(): string {
      switch (this.idx) {
        case 0:
          return "filter: invert(48%) sepia(96%) saturate(5311%) hue-rotate(197deg) brightness(90%) contrast(99%);";
        case 1:
          return "filter: invert(15%) sepia(77%) saturate(5033%) hue-rotate(338deg) brightness(86%) contrast(90%);";
        case 2:
          return "filter: invert(67%) sepia(85%) saturate(1408%) hue-rotate(358deg) brightness(99%) contrast(92%);";
        case 3:
          return "filter: invert(49%) sepia(75%) saturate(6803%) hue-rotate(122deg) brightness(102%) contrast(85%);";

        default:
          return "";
      }
    },
  },
});
</script>
